/* Base.java - Base. */

/* 
 * Copyright (C) 1996 Mark Boyns <boyns@sdsu.edu>
 *
 * Missile Commando II
 * <URL:http://www.sdsu.edu/~boyns/java/mcii/>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.awt.Graphics;
import java.awt.Color;
import java.awt.Image;

class Base extends GameObject
{
    int x, y, w, h;
    Image baseImage;
    MissileCommando parent;
    
    Base (int x, int y, int w, int h, Image baseImage, MissileCommando parent)
    {
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.baseImage = baseImage;
	this.parent = parent;
    }

    void erase (Graphics g)
    {
	g.setColor (skyColor);
	g.fillRect (x, y, w, h);
    }

    void paint (Graphics g)
    {
	if (explode)
	{
	    //erase (g);
	    alive = false;
	    explode = false;
	}
	
	if (alive)
	{
	    //g.setColor (Color.blue);
	    //g.fillRect (x, y, w, h);
	    g.drawImage (baseImage, x, y, w, h, parent);
	}
    }

    void rebuild ()
    {
	alive = true;
	explode = false;
    }
}
